# include "typedef.h"

/* (c) Copyright 1990 by Jotun Hein.  This program can be copied as long as
   this message is not deleted and it is distributed free of charge */

extern int (*nodes) [4], mutd[MAXSIGNS][MAXSIGNS],*adr, globali(), (*tipsintree)[5];
extern arrow *links;
extern float corr();
extern char cv(), *alig;
extern FILE *pout, *pphyl, *pin2;
extern struct auxheap *heap;

int di(),*posi,sonmut(),known();
float finv(),getit(),corr();
char logtide(),*calloc(),*ecalloc(),*emalloc(),*malloc();
int twopower[MAXSIGNS];

extern struct outstat oust;
extern struct param para;
extern struct back track;
extern struct esko ukko;
extern struct pres prep;
extern struct metp met;
extern struct treep t;
extern struct sekvens *sek;
extern struct globa globs;
extern struct inpar parr;
extern struct alilocspe als;


/* initializes parameters that depends on whether DNA or protein */

initall()
{
para.nd=3;
t.discycmax=3*(int)log((float)parr.nuseq);  
if (parr.seqtype){
 para.signnu=22;para.as=20;
 para.sl=3;para.ts=7999;
 inmatrix(22);
 acode();
 indata();
 para.i1=20; para.i2=18; para.i3=20; para.i4=19; 
 para.d1=(-1.0)*(0.95); para.d2=1.0/19.0;
 }
else {
 para.signnu=15;para.as=4;
 inmatrix(22);
 inmatrix(15);
 ncode();
 indata();
                                         {para.sl=5;para.ts=1023;}
 if (globs.lave>200)                     {para.sl=6;para.ts=4095;}
 if (globs.lave>2000)                    {para.sl=7;para.ts=16383;}
 if (globs.lave>6000)                    {para.sl=8;para.ts=65535;}
 para.i1=8; para.i2=5; para.i3=3; para.i4=2; 
 para.d1=(-1.0)*(0.666); para.d2=0.625;
 }
}

allo_stuff()
{int i;

 globs.totno=2*parr.nuseq+5;
 globs.nmax=2*globs.maxlen;

 oust.poiar=(int (*) [3])emalloc(3*globs.nmax*sizeof(int));
 
 ukko.ladder=(int *)emalloc(globs.nmax*sizeof(int));
 ukko.row=(int *)emalloc(globs.nmax*sizeof(int));
 ukko.dx=(int *)emalloc(globs.nmax*sizeof(int));
 ukko.dy=(int *)emalloc(globs.nmax*sizeof(int));

 track.aux=(struct nucnode *)emalloc(globs.nmax*sizeof(struct nucnode));
 nodes=(int (*) [4])emalloc(globs.nmax*4*sizeof(int));
 track.edges=(int (*) [6])emalloc(4*globs.nmax*6*sizeof(int));

 prep.puffpos=(int (*) [2])emalloc(2*MXPUFF*sizeof(int));
 prep.posh=(int *)emalloc(globs.nmax*2*sizeof(int));
 prep.alipoi=(struct alinode *)emalloc(globs.nmax*sizeof(struct alinode));
 prep.hash=(struct elem *)emalloc((para.ts+1)*sizeof(struct elem));
 for (i=0;i<=para.ts;i++) {prep.hash[i].sqno=0;prep.hash[i].next=NULL;}

 met.dima=(int *)ecalloc(parr.nuseq*parr.nuseq,sizeof(int));
 met.dimaf=(float *)ecalloc(parr.nuseq*parr.nuseq,sizeof(float));

 adr=(int *)emalloc(globs.nmax*sizeof(int));
 posi=(int *)emalloc(globs.nmax*sizeof(int));
 heap=(struct auxheap *)emalloc(parr.nuseq*sizeof(struct auxheap));
 tipsintree=(int (*) [5])emalloc(5*parr.nuseq*sizeof(int));
 alig=(char *)emalloc(globs.nmax*(2*parr.nuseq-1)*sizeof(char));
 links=(arrow *)emalloc(globs.nmax*sizeof(arrow));

 wash_it();
}

wash_it()
{int i;
 for (i=0;i<globs.nmax;i++){
     track.aux[i].first=NULL;
    }
}

prune(s3)
int s3;
{int i;
 simpleprune();  
for (i=track.ltot;i>0;i--) 
 if (!node_type(i)) dfs1(i);
delabelize(track.ltot,1);
transfer(s3);
}

/* j is the the integer representation of ancestral character, n is
the integer representation of set at the son, jp number of the
ancestral character */

int
sonmut(jp,j,n)
int jp,j,n;
{int m=0;
 int i,k;
 if (!(j & n)){
  m=SBIG; 
  for (i=0,k=1;i<=para.signnu;i++,k<<=1)
   if (n & k) if (mutd[i][jp]<m) m=mutd[i][jp];
 }
 return(m);
} 

int
di(n1,n2)
int n1,n2;
{int i,j;
 int m=SBIG;
 if (n1 & n2) m=0; 
 else
 {for (i=0,j=1;j<=n1;i++,j<<=1)
  if (j & n1) m=min(m,sonmut(i,j,n2));
 }
return(m);
}

/* hfs(Hartigan-Fitch-Sankoff) takes two amino acid sets, n1 and n2,
   and puts the most parsimoneous ancestral set in *n */

hfs(n1,n2,n)
int n1,n2,*n;
{int i,j;
 int m;
if (n1 & n2) (*n) =(n1 & n2);
else
 { m=di(n1,n2); 
   (*n)= n1 | n2;
   for (i=0,j=1;i<=para.signnu;i++,j<<=1) if (j & (*n))
                             if (m!=sonmut(i,j,n1)+sonmut(i,j,n2)) 
                              (*n)=(*n) & (~j);
 }
}

/* given set of nucleotides *n and one nucleotide, *n is changed to only 
   contain a closest nucleotide in *n */

dobbelt(n,pos)
int *n,pos;
{int i,j,jr,m=SBIG;
 for (i=0,j=1;j<=(*n);i++,j<<=1)
  if (j & (*n))
   if (mutd[i][pos]<m){
    m=mutd[i][pos];
    jr=j;
  }
 *n=jr;
}

/* given two sets of nucleotides *nl and *nr one ancestral nucleotide, pos,  
   nucleotides are chosen in *nl and *nr so distance from ancestral nuc. to
   daughters are minimal */

triple(nl,nr,pos)
int *nl,*nr,pos;
{int i1,j1,jr1,i2,j2,jr2;
 int m=SBIG;
 for (i1=0,j1=1;j1<=(*nl);i1++,j1<<=1)
  for (i2=0,j2=1;j2<=(*nr);i2++,j2<<=1)
   if ((j1 & (*nl)) && (j2 & (*nr)))
    if (mutd[i1][pos]+mutd[i2][pos]<m){
     m=mutd[i1][pos]+mutd[pos][i2];
     jr1=j1;
     jr2=j2;
   }
 *nl=jr1;
 *nr=jr2;
}

inmatrix(signs)
int signs;
{int i,j;
 for (i=0;i<=signs;i++)
   for (j=0;j<i;j++)
   {fscanf(pin2,"%d",&mutd[i][j]);
    mutd[j][i]=mutd[i][j];
   }
 for (i=0;i<=signs;i++) mutd[i][i]=0;
 fscanf(pin2,"\n\n");
/* 
 for (i=0;i<=signs;i++)
   {for (j=0;j<=signs;j++)
     printf("  %d",mutd[i][j]);
    printf("\n");
   } 
*/
}

ncode()
{para.acids[0]='A';
 para.acids[1]='C'; 
 para.acids[2]='G'; 
 para.acids[3]='T'; 
 para.acids[4]='U';
 para.acids[5]='R'; /* a or g */
 para.acids[6]='Y'; /* c or t */
 para.acids[7]='M'; /* a or c */
 para.acids[8]='K'; /* g or t */
 para.acids[9]='S'; /* c or g */
 para.acids[10]='W';/* a or t */
 para.acids[11]='H';/* a, c or t */
 para.acids[12]='B';/* c, g or t */
 para.acids[13]='V';/* a, c or g */
 para.acids[14]='D';/* a, g or t */
 para.acids[15]='N';/* any */
 
 twopower[0]=1;
 twopower[1]=2;
 twopower[2]=4;
 twopower[3]=8;
 twopower[4]=8;
 twopower[5]=5;
 twopower[6]=10;
 twopower[7]=3;
 twopower[8]=12;
 twopower[9]=6;
 twopower[10]=9;
 twopower[11]=11;
 twopower[12]=14;
 twopower[13]=7;
 twopower[14]=13;
 twopower[15]=15;
}

acode()
{para.acids[0]='C';/* cyt */   
 para.acids[1]='S'; /* ser */
 para.acids[2]='T'; /* tyr */
 para.acids[3]='P'; /* pro */
 para.acids[4]='A'; /* ala */
 para.acids[5]='G';/* gly */
 para.acids[6]='N';/* aspn*/
 para.acids[7]='D';/* glu */
 para.acids[8]='E';/* asp */
 para.acids[9]='Q';/* gln */
 para.acids[10]='H';/* his */ 
 para.acids[11]='R';/* arg */
 para.acids[12]='K';/* lys */
 para.acids[13]='M'; /* met */
 para.acids[14]='I'; /* ile */
 para.acids[15]='L'; /* leu */
 para.acids[16]='V'; /* val */
 para.acids[17]='F'; /* phe */
 para.acids[18]='Y'; /* tyr */
 para.acids[19]='W';/* tryp*/
 para.acids[20]='B';/* Asx (8,6) */ 
 para.acids[21]='Z';/* Glx (7,9) */
 para.acids[22]='X';/* ANY */
 para.acids[23]=';';/* stop*/

 twopower[0]=1;
 twopower[1]=2;
 twopower[2]=4;
 twopower[3]=8;
 twopower[4]=16;
 twopower[5]=32;
 twopower[6]=64;
 twopower[7]=128;
 twopower[8]=256;
 twopower[9]=512;
 twopower[10]=1024;
 twopower[11]=2048;
 twopower[12]=4096;
 twopower[13]=8192;
 twopower[14]=16384;
 twopower[15]=32768;
 twopower[16]=65536;
 twopower[17]=131072;
 twopower[18]=262144;
 twopower[19]=524288;
 twopower[20]=320;
 twopower[21]=640;
 twopower[22]=1048575;
 twopower[23]=0;
}

/* return 2-power corresponding to c */

int amino(c)
char c;
{int i;
 for (i=0;i<=para.signnu;i++)
  if (c==para.acids[i]) return(twopower[i]);
return(0);
}

/* corr performs jukes-cantor like correction on the minimal number of
events between two sequences */

float corr(i,la)
int i;
int la;
{float r;
 int l;
 l=(int)la;
 if (para.i1*i<para.nd*l*para.i2)
   r=para.d1*l*para.nd*log(1.0-((para.i3*(float)i/para.nd)/((float)l*para.i4)));
else r=para.d1*para.nd*l*log(1.0-(para.i3*(float)(l*para.i2/para.i1)/((float)l*para.i4)));
return(r);
}

/* I: Miscellaneous procedures */

/* emalloc returns adress to dynamical allocation */

char * 
emalloc(z)
unsigned int z;
{char *ad;
 ad=malloc(z);
if (!ad) 
  {printf("serious alloproblems\n");fprintf(pout,"serious allo\n");exit(0);}
else return(ad);
}

/* emalloc returns adress to dynamical allocation */

char * 
ecalloc(n,z)
int n;
unsigned int z;
{char *ad;
ad=calloc(n,z);
if (!ad) 
  {printf("serious alloroblems\n");fprintf(pout,"serious allo\n");exit(0);}
else return(ad);
}

/* first chooses nucleotide in nucleotideset in reverse alphabetical order */

int
first(i)
int i;
{int k,j;
 for (k=0,j=1;k<=para.signnu;k++,j<<=1) 
  if (i & j) return(j);
}

/* returns the order of a nucleotide */

char
logtide(i)
int i;
{int k,j;
 for (k=0,j=1;k<=para.signnu;k++,j<<=1)
  if (i & j) return((char)k);
}

/* cv turns integers into chars */

char
cv(i)
int i;
{int j,k;
for (k=0,j=1;k<=para.signnu;k++,j<<=1)
 if (j==i) return(para.acids[k]);
}


/* TREE PROCEDURES */

/* known returns the distance between sa and sb, at least 1 though, if it is 
   known, otherwise 0 */

int 
known(sa,sb)
int sa,sb;
{return(max(gdima(sa,sb),gdima(sb,sa)));}


/* getit returns the corrected distance between sa and sb, if they
   have not been aligned before then it aligns them */

float 
getit(sa,sb,t)
int sa,sb,t;
{int k;
  if (sa>sb) {k=sa; sa=sb; sb=k;}
  if (!gdima(sb,sa)) {pdima(sa,sb,globali(sa,sb,0));
                      pdima(sb,sa,1);}
  if (t) return(corr(gdima(sa,sb),globs.lave));
  else return((float)gdima(sa,sb));
}

/* dinv - float invert */

float 
finv(d)
float d;
{if (d==0.0) return(FBIG); /*return(FBIG);*/
 else return(1.0/d);
}

/* FREEING of DYNAMICAL STRUCTURES */

/* clean3 and drop3 removes unnecessary edges as reveiled by the
pruning procedure */

clean3(beg,slut)
int beg,slut;
{int i;
 for (i=beg;i>slut;i--) drop3(&track.aux[i].first,i);
}

drop3(p,i)
struct nuclink **p;
int i;
{struct nuclink *ph;
 if ((*p)!=NULL){
  drop3(&(*p)->next,i);
  if (!(*p)->nesc){
   ph=(*p);
   (*p)=ph->next;
   free(ph);
  }
 }
}   

/* frees nuclink ass. with a sequence, se,.  used in parnni.c */

clean4(se)
int se;
{int i;
 for (i=1;i<=sek[se].len;i++){
   drop4(sek[se].s[i].first);
 }
}

drop4(p)
struct nuclink *p;
{if (p!=NULL){drop4(p->next);free(p);}
}

/* evaporate frees the auxillary tree when a suitable amount of its
tips have been eaten */

evaporate(p)
struct auxnode *p;
{if (!p->tip){evaporate(p->left);
              evaporate(p->right);}
 free((char *)p);
}

