#include "typedef.h"

/* (c) Copyright 1990 by Jotun Hein.  This program can be copied as long as
   this message is not deleted and it is distributed free of charge */

/* dis rearranges preliminary tree in order to obtain more parsimoneous tree 
nd it let tdistree.c do the merging */

struct bfsa {
 struct node *p;
 float depth;
};

struct node auxtree,**grandchild,**childup;

extern int known(), newwei;
extern FILE *pout,*pin,*pphyl;
extern struct node *trees();
extern char *emalloc();
extern float finv(),getit();

int (*tipsintree)[5] ,bladcount[5];
int remedge, remdis, sample=5, improved, add;
float dismas[3][3], afstand(), remlen, bridge, disconfig();
struct bfsa arbfsa[100];
int bfsano;

extern struct inpar parr;
extern struct treep t;
extern struct aliglospe ags;

/* improve continues to subject the phylogeny to cycles of nni as long as improvements are obtained */

improvedis()
{int i;
 mft();
 improved=1;
 for (i=1;i<=t.discycmax && improved;i++)
 {improved=0;
  treeinit(t.top);
  iev(0); 
 if (parr.screen) printf("finished cycle no %d of improving distance tree\n",i);
 }
 if (parr.usertrae==2){traeud();outmat();exit(0);}
}

/* m(ake) f(our) t(rees) makes four initial parsimony trees from the 
   prelimenary distance tree on which nni operations can be performed */

mft()
{
 t.top->left=(struct node *)emalloc(sizeof(struct node));
 t.top->left->last=NULL;
 t.top->right=(struct node *)emalloc(sizeof(struct node));
 t.top->right->last=NULL;
 t.top->sqno=2*parr.nuseq-2;
 t.top->left->sqno=2*parr.nuseq-3;
 t.top->right->sqno=2*parr.nuseq-4;
 t.top->left->tip=t.top->right->tip=0;
 ags.s3=parr.nuseq-1;

 mergedive(&t.top->left->left,&t.plt);
 t.top->left->left->dislen=t.plt.leftlen;

 if (!t.plt.left->left->tip){
  mergedive(&t.top->left->right,t.plt.left->right);
  mergedive(&t.top->right->left,t.plt.left->left->left);
  mergedive(&t.top->right->right,t.plt.left->left->right);
  t.top->left->dislen=t.top->right->dislen=t.plt.left->leftlen;
 }
 else{
  mergedive(&t.top->left->right,t.plt.left->left);
  mergedive(&t.top->right->left,t.plt.left->right->left);
  mergedive(&t.top->right->right,t.plt.left->right->right);
  t.top->left->dislen=t.top->right->dislen=t.plt.left->rightlen;
 }
t.top->left->up=(int)t.top->left->dislen;
t.top->right->up=(int)t.top->right->dislen;
}

/* bladlist */

bladlist(pos)
int pos;
{float dp;
 struct node *p;
 int j;
 dp=arbfsa[pos].depth;
 p=arbfsa[pos].p;
 if (!p->tip){
  removeright(pos); 
  putright(p->left,dp+p->left->dislen);
  putright(p->right,dp+p->right->dislen);
 }
 j=doneornot(); 
 if (j) bladlist(j);
} 

removeright(pos)
int pos;
{int i;
 for (i=pos;i<=bfsano;i++) arbfsa[i]=arbfsa[i+1];
bfsano--;
}

putright(p,dp)
struct node *p;
float dp;
{int i=bfsano+1;
 while (arbfsa[i-1].depth<dp){
  arbfsa[i]=arbfsa[i-1];
  i--;
 }
 arbfsa[i].p=p;
 arbfsa[i].depth=dp;
 bfsano++;
}

int doneornot()
{int j=bfsano;
 while (arbfsa[j].p->tip && j>max(bfsano-sample,1)) j--;
 if (j==bfsano-sample || arbfsa[j].p->tip) j=0;
 return(j);
}

blade()
{int i,j;
 arbfsa[0].depth=100000.0; 
 for (i=1;i<=4;i++){
  arbfsa[1].p=trees(i);
  arbfsa[1].depth=0.0;
  bfsano=1;
  bladlist(1);
  bladcount[i]=min(sample,bfsano);
  for (j=1;j<=bladcount[i];j++) tipsintree[j][i]=arbfsa[bfsano-j+1].p->sqno;
 }
}

/* afstand calculates a weighted distance between tips in tree t1 and trees
   in tree t2 based only on known distances.  It is problematic because of the 
   sparse matrix and should be improved so the six distances between the four
   subtrees are based on comparable sequences  */

float
afstand(t1,t2)
int t1,t2;
{int i,j;
 float r=0.0,w,wtot=0.0,x;
 for (i=1;i<=bladcount[t1];i++)
  for (j=1;j<=bladcount[t2];j++){
    x=getit(tipsintree[i][t1],tipsintree[j][t2],0);
    w=finv(x)*finv(x);
    r+=x*w;
    wtot+=w;
   }
 return(r/wtot);
}

/* disswapit checks the three configurations and rearranges towards the one
   that fits the distance data best */

disswapit()
{int m;
 blade();
  m=choose();
  if (!m){}
  else if (m==1){
  if (parr.screen) printf("found improvement: %d\n",m);
  improved=1;
  auxtree=(*t.top->left->right);
  *t.top->left->right=(*t.top->right->right);
  *t.top->right->right=auxtree;
}
 
 else if (m==2){
  if (parr.screen) printf("found improvement: %d\n",m);
  improved=1;
  auxtree=(*t.top->left->right);
  *t.top->left->right=(*t.top->right->left);
  *t.top->right->left=auxtree;
}

   t.top->left->done=(t.top->left->left->done && t.top->left->left->edge &&
		    t.top->left->right->done && t.top->left->right->edge);

   t.top->right->done=(t.top->right->left->done && t.top->right->left->edge &&
		    t.top->right->right->done && t.top->right->right->edge);

 t.top->left->edge=t.top->right->edge=1;

 t.top->left->dislen=t.top->right->dislen=bridge/2;
 t.top->left->up=t.top->right->up=(int)(bridge/2);

}

int
choose()
{float treewei[3],large=0.0,little=FBIG,small=FBIG,totadd=0.0,smalladd=FBIG;
int i,j,vi,vj;
for (i=1;i<=3;i++)
 for (j=i+1;j<=4;j++)
  {dismas[i-1][j-2]=afstand(i,j);
   if (small>dismas[i-1][j-2]) {vi=i;vj=j;small=dismas[i-1][j-2];}
   if (large<dismas[i-1][j-2]) large=dismas[i-1][j-2];
  }

for (i=1;i<=3;i++)
 for (j=i+1;j<=4;j++)
   if (little>dismas[i-1][j-2] && (i!=vi || j!=vj) && (i==vi || j==vj)) 
    little=dismas[i-1][j-2];

for (i=0;i<3;i++)
 {totadd+=treewei[i]=disconfig(i);
  if (treewei[i]<smalladd) {add=i;smalladd=treewei[i];}                 
 }

bridge=(totadd-3*smalladd)/4.0;

return(add);

}

/* disconfig evaluates the fitness of the top of the tree if it has 
   configuration (t1,t2)(t3,t4) */

float
disconfig(t)
int t;
{float r;
 if (!t)   r=dismas[0][0]+dismas[2][2];
 if (t==1) r=dismas[0][2]+dismas[1][1];
 if (t==2) r=dismas[0][1]+dismas[1][2];
 return(r);
}

/* o(ver) s(houlder) fuses t3 & t4 into t4, fises t1 into t1 & t2 and moves
   t2 into t3 */

postos(ty)
int ty;
{struct node *auxp;
 auxp=(*grandchild);
 *grandchild=(*childup);
 *childup=auxp;
 if (ty>2) rotate(t.top->right);
 else      rotate(t.top->left);
 rotate(t.top);
 
 t.top->left->dislen=t.top->right->dislen=remlen;
 t.top->left->up=t.top->right->up=remdis/2;
   
 t.top->left->edge=t.top->right->edge=remedge;
}

rotate(p)
struct node *p;
{struct node *auxp;
if (!p->tip){auxp=p->left;p->left=p->right;p->right=auxp;
             p->done=(p->left->done && p->left->edge &&
		    p->right->done && p->right->edge);}
}

sos(ty,u)
int ty,u;
{
 preos(ty);
if (u){
  if (ty<=2) clean4(t.top->left->sqno);
  else clean4(t.top->right->sqno);
  clean4(t.top->sqno);
 }
 postos(ty);
if (u){
  if (ty>=3) iniback(t.top->left);
  else      iniback(t.top->right);
  iniback(t.top);
  newwei=t.top->wei;
 }
}

preos(t1)
int t1;
{switch (t1){
  case   2: {grandchild=(&t.top->left->right);
	     remlen=t.top->left->right->dislen;
	     remdis=t.top->left->right->up;
	     remedge=t.top->left->right->edge;
	     break;
	    }
  case   1: {grandchild=(&t.top->left->left);
	     remlen=t.top->left->left->dislen;
	     remdis=t.top->left->left->up;
	     remedge=t.top->left->left->edge;
             break;
	    }
  case   4: {grandchild=(&t.top->right->right);
	     remlen=t.top->right->right->dislen;
	     remdis=t.top->right->right->up;
	     remedge=t.top->right->right->edge;
             break;
	    }
  case   3: {grandchild=(&t.top->right->left);
	     remlen=t.top->right->left->dislen;
	     remdis=t.top->right->left->up;
	     remedge=t.top->right->left->edge;
             break;
	    }
 }

t.top->left->up*=2;
t.top->right->up*=2;

 if (t1>2) childup=(&t.top->left);
 else       childup=(&t.top->right);
}

goon(t)
int t;
{int i,j=0;
 for (i=4;i>0;i--) if (!trees(i)->done || !trees(i)->edge) j=i;
 if (j) {sos(j,t);iev(t);}
}

/* mergedive dives down a distance tree and turns it into a parsimony tree */

mergedive(pn,pa)
struct node **pn;
struct auxnode *pa;
{*pn=(struct node *)emalloc(sizeof(struct node));
 (*pn)->last=NULL;
 if (!pa->tip){
     mergedive(&(*pn)->left,pa->left); 
     mergedive(&(*pn)->right,pa->right); 
     ags.s3++;
     (*pn)->sqno=ags.s3;
     (*pn)->tip=0;
    }
 else {(*pn)->sqno=pa->sqno; 
       (*pn)->wei=0;
       (*pn)->tip=1;}
 (*pn)->dislen=pa->uplen;
 (*pn)->up=(int)pa->uplen;
} 

