#include "typedef.h"

# define LL 80 /* page with in tree-drawing */
# define PS 200  /* line number in page with tree-drawing */
# define SHED 1  /* length of shortest edge in tree-drawing */ 

/* (c) Copyright 1990 by Jotun Hein.  The program can be copied as long as
   this message is not deleted and it is distributed free of charge */

extern FILE *pphyl;
extern float finv();

static char ark[LL][PS];
static int lastline,tips,dybde,shortest=SBIG,spids[5],leftdir,rightdir;
static int midt,enkelt;
static float sf;

extern struct treep t;
extern struct inpar parr;

tegntrae()
{if (parr.nuseq<PHYSIZE){
  rearra(t.top);
  outphyl(t.top);
  fprintf(pphyl,";\n");
  traeud();
 }
else{
 outphyl(t.top);
 fprintf(pphyl,"\n Too complex tree to be drawn\n");
    }
}

 traeud()
{initark();
 fprintf(pphyl,"\n CAUTION: This tree is rooted assuming a clock, which might not be justified.");
 fprintf(pphyl,"\n The exact branch lengths can be found in the nested parenthesis representation");
 fprintf(pphyl,"\n just above. Lengths are roughly proportional to vertical lines.");
 enkelt=LL/parr.nuseq;
 deepest(t.top,&dybde);
 shortest=max(shortest,1);
 sf=(float)SHED*finv((float)shortest);
 while (sf*(float)shortest<(float)SHED) sf*=1.05;
 if (sf*(float)dybde>(float)(PS-10)) sf=(float)(PS-10)/(float)dybde;
 drawtree(t.top,0,79,0);
 udark();
}

rearra(p)
struct node *p;
{if (!p->left->tip)
  {deepest(p->left->left,&spids[1]);
   deepest(p->left->right,&spids[2]);
   spids[1]+=p->left->left->up;
   spids[2]+=p->left->right->up;
}
 else spids[1]=spids[2]=(-1)*SBIG;
 if (!p->right->tip)
  {deepest(p->right->left,&spids[3]);
   deepest(p->right->right,&spids[4]);
   spids[3]+=p->right->left->up;
   spids[4]+=p->right->right->up;
  }
 else spids[3]=spids[4]=(-1)*SBIG;
if (spids[1]>spids[2]) leftdir=1;
else                   leftdir=2;
if (spids[3]>spids[4]) rightdir=3;
else                   rightdir=4;
vaelg();
}

vaelg()
{int ldep,rdep;
 rdep=t.top->right->up;
 if (!t.top->right->tip) rdep+=spids[rightdir];
 ldep=t.top->left->up;
 if (!t.top->left->tip) ldep+=spids[leftdir];
 midt=(ldep+rdep)/2;
 if (midt>ldep+t.top->right->up) 
   {sos(rightdir,0);rearra(t.top);}
 else if (midt<ldep-t.top->left->up) {sos(leftdir,0);rearra(t.top);}
 else centralize();
}

centralize()
{if (!t.top->left->tip) t.top->left->up=midt-spids[leftdir];
 else                 t.top->left->up=midt;
 if (!t.top->right->tip) t.top->right->up=midt-spids[rightdir];
 else                    t.top->right->up=midt;
}

int initark()
{int i,j;
 lastline=0;
 for (i=0;i<LL;i++)
  for (j=0;j<PS;j++) ark[i][j]=' ';
}

int descendants(p)
struct node *p;
{tips=0;
 counttips(p);
 return(tips);
}

deepest(p,d)
struct node *p;
int *d;
{int dl,dr;
 if (!p->tip){
              deepest(p->left,&dl);
              deepest(p->right,&dr);
              (*d)=max(dl+p->left->up,dr+p->right->up);
             }
 else (*d)=0; 
 if (p!=t.top) shortest=min(p->up,shortest);
}

counttips(p)
struct node *p;
{if (!p->tip){counttips(p->left);
              counttips(p->right);
             }
 else tips++;
}

scale(i)
int i;
{return((int)((float)i*sf));}

drawtree(p,x,y,z)
struct node *p;
int x,y,z;
{int lefts,rights,leftp,rightp;
 if (!p->tip){
  lefts=descendants(p->left);
  rights=descendants(p->right);
  leftp=x+(y-x)*lefts/(2*(lefts+rights)); 
  rightp=leftp+(int)((float)(y-x)*0.5);
  drawh(leftp,rightp,scale(z));
  drawv(leftp,scale(z),scale(z+p->left->up)); 
  drawv(rightp,scale(z),scale(z+p->right->up));
  drawtree(p->left,leftp-(int)(0.5*(float)(enkelt*lefts)),
           leftp+(int)(0.5*(float)(enkelt*lefts)),z+p->left->up);
  drawtree(p->right,rightp-(int)(0.5*(float)(enkelt*rights)),
           rightp+(int)(0.5*(float)(enkelt*rights)),z+p->right->up);
  putseq(p->left->sqno,leftp,scale(z+p->left->up));
  putseq(p->right->sqno,rightp,scale(z+p->right->up));
 }
}

int drawh(x1,x2,y)
int x1,x2,y;
{int i;
 for (i=x1;i<=x2;i++)
  ark[i][y]='-';
}

int drawv(x,y1,y2)
int x,y1,y2;
{int i;
 for (i=y1;i<=y2;i++)
  ark[x][i]='|';
 lastline=max(lastline,i);
}

int putseq(no,x,y)
int no,x,y;
{int i,j=no,k=no,l=0;
 if (no>=parr.nuseq) l=1;
 for (i=1,j=1;i<=no+1;i*=10,j++){} j--; 
 for (i=j;i;i--) {ark[x][y+i-l]='0' + (k % 10); k/=10;}
}

udark()
{int i,j;
  fprintf(pphyl,"\n\n");
 for (i=0;i<lastline+5;i++){
  for (j=0;j<LL;j++) fprintf(pphyl,"%c",ark[j][i]);
  fprintf(pphyl,"\n");
 }
}

