#include "typedef.h"

/* graph does diverse things to sequence graph, finds articulation points, 
   puffs and adds dummy edges */

/* (c) Copyright 1990 by Jotun Hein.  This program can be copied as long as
   this message is not deleted and it is distributed free of charge */

extern int (*nodes) [4], di(),*adr,*posi;
extern FILE *pout;
extern arrow *links;
extern char *emalloc();

static int pos1,pos2,pos2o;

extern struct pres prep;
extern struct param para;
extern struct esko ukko;
extern struct back track;
extern struct globa globs;
extern struct alilocspe als;
extern struct sekvens *sek;
extern struct inpar parr;


dfs1(o)
int o;
{struct nuclink *poi=track.aux[o].first;
 while (poi!=NULL){
   if (node_type(poi->nextnode)>0){
      ininode(poi->nextnode); 
      dfs2(poi->nextnode,poi->nextnode,node_type(poi->nextnode)); 
   }
   poi=poi->next;
 }
}

node_type(i)
int i;
{struct nuclink *p=track.aux[i].first;
 int t=0;
 while (p!=NULL){t=max(t,p->type); p=p->next;}
 return(t);
}

ininode(b)
int b;
{struct nuclink *p=track.aux[b].first;
 while (p!=NULL)
   {if (nodes[b][0])
       ininode(p->nextnode);
    p=p->next;
   }
 nodes[b][0]=0;
}

dfs2(o,p,t)
int o,p,t;
{struct nuclink *poi=track.aux[p].first;
 if (node_type(p)==t && !nodes[p][0])
    {nodes[p][0]=1;
      while (poi!=NULL){dfs2(o,poi->nextnode,t);poi=poi->next;} 
    }
 if (!node_type(p)) adddummy(o,p,t);  
}


adddummy(b,e,t)
int b,e,t;
{struct nuclink *p;
 if (track.aux[b].first->nextnode!=e || track.aux[b].first->type>=0){
    p=(struct nuclink *)emalloc(sizeof(struct nuclink));
    p->next=p->left=p->right=NULL;
    p->nesc=p->nucset=0;
    p->next=track.aux[b].first;
    track.aux[b].first=p;
    p->type=(-1)*t;
    p->nextnode=e;
 }
}  

/* DUMMY-ADDITION ENDS */

bfsg(sg,b2,l)
struct nucnode *sg;
int b2,l;
{int x,i,j,k;
 struct nuclink *poi;
 for (i=0;i<=l;i++) {posi[i]=adr[i]=ukko.ladder[i]=0;}
 track.blokno=ukko.ladder[l]=1;ukko.used=1;
 pos1=pos2=0;pos2o=track.blok[0]=0;adr[0]=l;

 while (pos1!=(pos2+1)){ /* this condition would imply array is empty */
    x=adr[pos1];
    poi=sg[x].first;
    while (poi!=NULL){
       if (!posi[poi->nextnode-b2]) adnode(sg,poi->nextnode-b2,b2);
       poi=poi->next;
      }
    ukko.used+=(1+ukko.dy[adr[pos1]]-ukko.dx[adr[pos1]]);
    pos1++; /* this is deleting an element from the queue */
    k=pos1-1; 
  
   while (k>track.blok[track.blokno] && adr[k]>adr[k-1])
      {j=adr[k]; adr[k]=adr[k-1]; adr[k-1]=j; k--;} 
   if ((ukko.used>(int)(0.5*globs.nmaxl) 
          && (globs.nmaxl<globs.tota)) || pos1==als.l2) 
      newblok();
 }

blokmake();
}

adnode(sg,n,b2)
struct nucnode *sg;
int n,b2;
{int j,k,boo=0;
 struct nuclink *p=sg[n].first;

 while (p!=NULL){
    if (ukko.ladder[p->nextnode-b2]<track.blokno && posi[p->nextnode-b2]==1) 
       boo=1;
    p=p->next;
    }

 if (boo) posi[n]|=4;
 posi[n]|=1;
 pos2++;adr[pos2]=n; /* a node is added to the queue */
 if (pos1>=track.blok[track.blokno]){
    k=pos2; 
    while (k>pos1 && adr[k]>adr[k-1]){
       j=adr[k]; adr[k]=adr[k-1]; adr[k-1]=j; k--;} 
 }

 ukko.ladder[n]=track.blokno;
}

newblok()
{int j;
 for (j=pos1;j<=pos2;j++) posi[adr[j]]|=4;
 ukko.used=1;track.blokno++;track.blok[track.blokno]=pos2+1;
}

blokmake()
{int i,j,refs=0;
 ukko.maxused=0;

 for (i=1;i<track.blokno;i++){
    ukko.used=1;
    for (j=track.blok[i];j<track.blok[i+1];j++)
       if (!(posi[adr[j]] & 4)) {
          ukko.row[adr[j]]=ukko.used-ukko.dx[adr[j]]; 
          ukko.used+=(1+ukko.dy[adr[j]]-ukko.dx[adr[j]]);
       }
    ukko.maxused=max(ukko.used,ukko.maxused);
 }

 ukko.used=ukko.maxused;

 for (i=0;i<=als.l2;i++)
   if (posi[adr[i]] & 4){
      ukko.row[adr[i]]=ukko.used-ukko.dx[adr[i]];
      ukko.ladder[adr[i]]=0;
      refs++;
      ukko.used+=(1+ukko.dy[adr[i]]-ukko.dx[adr[i]]);
    } 

track.presblok=1;
if (parr.screen>1) 
   printf("maxused,track.blokno,refs %d  %d  %d\n"
           ,ukko.maxused,track.blokno,refs);
if (ukko.used>globs.nmaxl) {printf("out of mem (2)\n");exit(0);}
}
 
/* PRUNING STARTS */

findpuff()
{int i,maxchild=track.ltot-1;
 track.inpuff=0;
 for (i=track.ltot;i>=0;i--){
    if (track.inpuff && maxchild==i)
       {track.inpuff=0;track.slut=i;pruneit();}
    if (!track.inpuff && maxchild==i && outdeg(track.aux[i].first)>1)
       {track.inpuff=1;track.beg=i;}
    maxchild=min(oldest(&track.aux[i]),maxchild);
  }
}

int outdeg(p)
struct nuclink *p;
{int i=0;
 while (p!=NULL){i++;p=p->next;}
 return(i);
}

findpuffgr(sg,len)
struct nucnode *sg;
int len;
{int k=0,i,beg,slut,inpuff=0,maxchild=len;
 prep.puffno=0; prep.puffpos[0][1]=len-1;
 for (i=len;i>=0;i--){if (!inpuff) k++;
    if (inpuff && maxchild==i)
       {prep.puffpos[prep.puffno][0]=beg+1;
        inpuff=0;slut=i;
        if (prep.puffno==MXPUFF-2) {printf("too many puffs try %d\n",
                     (len*MXPUFF)/(len-i));exit(0);}
        prep.puffno=min(prep.puffno+1,MXPUFF-1);
        prep.puffpos[prep.puffno][1]=slut;}
    if (!inpuff && maxchild==i && outdeg(sg[i].first)>1) {inpuff=1;beg=i;}

    maxchild=min(oldest(&sg[i]),maxchild);
    }
 prep.puffpos[prep.puffno][0]=2;

return(k);
}

 
/* oldest returns the position of the node furthest down that can be 
   track.reached in one step from s */

oldest(n)
struct nucnode *n;
{int i=SBIG;
 struct nuclink *poi=n->first;
  while (poi!=NULL){
     i=min(i,poi->nextnode);
     poi=poi->next;
    }
 return(i);
}

/* simpleprune perfoms the pruning of the complete sequence graph */

simpleprune()
{
 track.inpuff=0;
 findpuff();
}

pruneit()
 {delabelize(track.beg,track.slut);track.enough=track.pathno1=track.pathno2=0;
  divepath1(track.beg,1);
  clean3(track.beg,track.slut);
 }

delabelize(e,b)
int e,b;
{int i;
 for (i=b;i<=e;i++) putzero(track.aux[i].first);
}

putzero(p)
struct nuclink *p;
{if (p!=NULL){p->nesc=0;putzero(p->next);}}

/* divepath generates all paths through a puff and creates a list from which
   they are hanging down */

divepath1(p,pathl)
int p,pathl;
{struct nuclink *poi=track.aux[p].first;
if (!track.enough)
   {if (p>track.slut)
      {while (poi!=NULL)
         {links[pathl]=poi;
          divepath1(poi->nextnode,pathl+1);
          poi=poi->next;
         }
      }
    else newpath(pathl-1);
   }
}

divepath2(p,auxpathl)
int p,auxpathl;
{struct nuclink *poi=track.aux[p].first;
 if (!track.reached){
    if (p==track.slut) track.reached=1;
       while (poi!=NULL){
          if (poi->nesc)
	     if (nucpare(links[auxpathl]->nucset,poi->nucset))
                divepath2(poi->nextnode,auxpathl+1);
          poi=poi->next;
          }
  }
}

/* newpath is called when divepath has completed another path */

newpath(pathl)
int pathl;
{track.reached=0;track.pathno1++; 
 if (track.pathno1>2000) 
    {track.enough=1;
     printf("pathcutting used track.pathno1 %d %d %d\n",
             track.beg,track.slut,track.pathno1);
    }
  divepath2(track.beg,1);
 if (!track.reached) {labelit(pathl);track.pathno2++;}
} 

labelit(d)
int d;
{if (d){links[d]->nesc=1;labelit(d-1);}}

/* nucpare compares two nucleotide sets and returns 1 if n1 is contained in n2
   and 0 otherwise */ 

nucpare(n1,n2)
int n1,n2;
{if ((n1&n2)==n1) return(1); 
 else return(0); 
}

/* PRUNING ENDS */

/* transfer takes the sequence graph in aux, throws away superflous nodes 
   the graph and puts in s3 */

transfer(s3)
int s3;
{int i,taelle=2;
 track.ltotr=0;
 
 for (i=1;i<=track.ltot;i++) 
    if (track.aux[i].first!=NULL) taelle++;

 sek[s3].s=(struct nucnode *)emalloc(taelle*sizeof(struct nucnode));

 for (i=0;i<taelle;i++) 
    sek[s3].s[i].first=NULL;  

 for (i=0;i<=track.ltot;i++) 
    if (outdeg(track.aux[i].first) || !i){
        sek[s3].s[track.ltotr]=track.aux[i];adr[i]=track.ltotr;track.ltotr++;
        track.aux[i].first=NULL;
       }

 track.ltotr--;

 for (i=0;i<=track.ltotr;i++) correctit(sek[s3].s[i].first);
 
 sek[s3].len=sek[s3].p->nl=track.ltotr;

 if (!track.ltotr || (track.ltotr>globs.nmax)) 
    {printf("problems: track.ltotr,s3: %d  %d\n",track.ltotr,s3);exit(0);} 
 if (!track.ltot || (track.ltot>globs.nmax)) 
    {printf("problems:track.ltot,s3: %d  %d\n",track.ltot,s3);exit(0);} 
 if (s3<0 || s3>=globs.totno) 
    {printf("problems:s3:  %d\n",s3);exit(0);} 
}

correctit(p)
struct nuclink *p;
{if (p!=NULL) {p->nextnode=adr[p->nextnode];correctit(p->next);}}
