#include "typedef.h"

/* (c) Copyright 1990 by Jotun Hein.  This program can be copied as long as
   this message is not deleted and it is distributed free of charge */

extern char logtide(),*emalloc();
extern FILE *pout;

extern struct pres prep;
extern struct inpar parr;
extern struct param para;
extern struct aliglospe ags;


/* sequences are hashed */

hashboth()
{
 hash_one(0);
 suspicious();
 hash_one(1);
 clean_array();
}

/* systems of internal repeats can confuse the program, so segments that occur
   very frequently are removed */

suspicious()
{int i,cutoff;
 cutoff=max(3,(25*ags.l[0])/para.ts);
 for (i=0;i<=para.ts;i++)
  if (prep.hash[i].sqno>cutoff) 
   {printf("garbage ts,len,sqno %d %d %d\n",para.ts,ags.l[0],prep.hash[i].sqno);
    drop_elem(prep.hash[i].next);prep.hash[i].sqno=0;prep.hash[i].next=NULL;}
}

/* no. sequence is hashed */

hash_one(no)
int no;
{if (!seq_kind(no)){
    ags.stln[no]=findpuffgr(ags.sg[no],ags.l[no]);
    hashitgr(ags.sg[no],no);
   }
 else {
    hashit(ags.se[no],ags.l[no],no);
    ags.stln[no]=ags.l[no];
   }
}

/* is it a sequence or a graph */

seq_kind(no)
int no;
{return(ags.s[no]<parr.nuseq);
}

/* are they both sequences */

seqs_kind()
{return(seq_kind(0) && seq_kind(1));
}

/* no. sequence is hashed */

hashit(se,len,no)
char *se;
int len,no;
{int j,m,l;
  m=0;
  for (l=(para.ts+1)/para.as,j=1;j<para.sl;j++,l/=para.as) 
     m+=l*sign_no(se[j]); 

  for (;j<=len;j++){
     m*=para.as;
     m+=sign_no(se[j]); 
     m=(m % (1+para.ts));
     if (!no) another_seg(m,j);
     else     add_seg(m,j);
  }
}

/* is used to merge 'U' & 'T' for nucleic acids */

int sign_no(c)
char c;
{if (!parr.seqtype) return(min(3,(int)c));
 else               return((int)c);
}

another_seg(m,j)
int m,j;
{struct elem *p;
  prep.hash[m].sqno++;
  p=(struct elem *)emalloc(sizeof(struct elem));
  p->next=prep.hash[m].next;
  p->sqno=j;
  prep.hash[m].next=p;
}

/* sequence graph, se, is prep.hashed */

hashitgr(sg,no)
struct nucnode *sg;
int no;
{int i,j,m,l;
 for (i=prep.puffno;i;i--)
 if ((prep.puffpos[i][1]-prep.puffpos[i][0])>para.sl) {
    m=0;
    for (l=(para.ts+1)/para.as,j=prep.puffpos[i][0];
                j<prep.puffpos[i][0]+para.sl;j++,l/=para.as)
        m+=l*sign_no(logtide(first(sg[j].first->nucset))); 
  
    for (;j<=prep.puffpos[i][1];j++){
        m*=para.as;
        m+=sign_no(logtide((first(sg[j].first->nucset))));
        m=(m % (1+para.ts));
        if (!no) another_seg(m,j);
        else     add_seg(m,j);
     }
  }
}

/* array is cleaned after hashing */

clean_array()
{int i;
 for (i=0;i<=para.ts;i++) 
   {drop_elem(prep.hash[i].next);prep.hash[i].sqno=0;prep.hash[i].next=NULL;}
}

drop_elem(p)
struct elem *p;
{if (p!=NULL) {drop_elem(p->next);free(p);}
}
