# include "typedef.h"

/* (c) Copyright 1990 by Jotun Hein.  This program can be copied as long as
   this message is not deleted and it is distributed free of charge */

extern int mutd[MAXSIGNS][MAXSIGNS],known(),di();
extern FILE *fopen(),*usertree,*pphyl,*pout,*pin,*par;
extern char logtide(),*alig,*emalloc(),cv();

static int tipno=0,phylpos=0,leafno=0,pos,nucocc[30];
char upp(),buf[100],usertreefile[30],strng[STLG];

extern struct param para;
extern struct treep t;
extern struct aliglospe ags;
extern struct globa globs;
extern struct inpar parr;

int fclose();
struct outstat oust;
struct sekvens *sek;


indata()
{int i,l;
 float f;
 globs.lave=0;
 sek=(struct sekvens *)emalloc((2*parr.nuseq+5)*sizeof(struct sekvens));
 for (i=0;i<parr.nuseq;i++){
    sek[i].p=(struct domain *)emalloc(sizeof(struct domain));
    sek[i].len=sek[i].p->nl=sek[i].p->al=l=seq_length(i); 
    allo_seqs(i,l);
    globs.lave+=l;
    if (l>globs.maxlen) globs.maxlen=l;
    if (parr.screen) printf("length of %d :  %d\n",i,l);
  }
 printf("finished reading sequences first time\n");
 globs.lave/=parr.nuseq;

i=fclose(pin);
open_seq_file();

 for (i=0;i<parr.nuseq;i++) inseq(i); 
 printf("finished reading sequences second time\n");
 
 para.la=0.0;
 for (i=0;i<=para.signnu;i++){
    f=(float)nucocc[i]/(float)(globs.lave*parr.nuseq);
    f*=f;
    para.la+=f;
 }
}

allo_seqs(sqno,l)
int sqno,l;
{
  sek[sqno].se=(char *)emalloc((l+2)*sizeof(char));
  sek[sqno].s=(struct nucnode *)emalloc((l+2)*sizeof(struct nucnode));
}


/* inseq reads sequence n into sequence graph n. It neglects all
signs that is not a known nucleotide */

int
seq_length(n)
int n;
{int l=0;
 char c;
 fgets(buf,100,pin);
 while (buf[0]!='>') fgets(buf,100,pin);
 fgets(buf,100,pin);
 if (parr.screen) printf("%d %s",n,buf);   
 fprintf(pout,"%d %s",n,buf);   
 fprintf(pphyl,"%d %s",n,buf);   
 fscanf(pin,"%c",&c);
 while (c!='*'){
    if (amino(upp(c))) l++; 
    fscanf(pin,"%c",&c);
 }
return(l);
}


/* inseq reads sequence n into sequence graph n. It neglects all
signs that is not a known nucleotide */

int
inseq(n)
int n;
{int l=0,ci;
 char c;
 sek[n].p->num=1;
 sek[n].p->sety=parr.seqtype;
 fgets(buf,100,pin);
 while (buf[0]!='>') fgets(buf,100,pin);
 fgets(buf,100,pin);
 fscanf(pin,"%c",&c);
 while (c!='*'){
    if (ci=amino(upp(c)))  
       {l++; addonechar(l,ci,n);} 
    fscanf(pin,"%c",&c);
 }
}

char
upp(c)
char c;
{if (c>='a' && c<='z') return(c + 'A' - 'a');
 else return(c);
}

addonechar(l,c,sqno)
int l,c,sqno;
{struct nucnode *s=sek[sqno].s;
 char *se=sek[sqno].se;
 se[l]=logtide(c);
 s[l].first=(struct nuclink *)emalloc(sizeof(struct nuclink));
 s[l].first->nextnode=l-1;
 s[l].first->nucset=c;
 s[l].first->type=0;
 s[l].first->next=NULL;
 nucocc[logtide(c)]++;
}

user()
{if (NULL==(usertree=fopen(usertreefile,"r")))
 {printf("file with usertree, %s, could not be opened\n",usertreefile);exit(0);}
 printf("entered user\n");
 maketree();
 mergedive2(&t.top,&t.plt);
}

/* maketree constructs tree from string on usertree. the relevant string starts 
   first ( and ends with ; */

maketree()
{struct auxnode *ptr=(&t.plt);
 instrng();
 pos=0;
 constree(&ptr);
 printf("finished making tree with %d nodes and %d tips:\n",tipno,leafno);
 fprintf(pphyl,"finished making tree with %d nodes and %d tips:\n",tipno,leafno);
fprintf(pphyl,"\n\n");
}

/* mergedive dives down a distance tree and turns it into a parsimony tree */

mergedive2(pn,pa)
struct node **pn;
struct auxnode *pa;
{*pn=(struct node *)emalloc(sizeof(struct node));
 (*pn)->last=NULL;
 if (!pa->tip){
  mergedive2(&(*pn)->left,pa->left); 
  mergedive2(&(*pn)->right,pa->right); 
  ags.s3=(*pn)->sqno=pa->sqno;
}
 else {(*pn)->sqno=pa->sqno; 
       (*pn)->wei=0;
       (*pn)->up=0;
       (*pn)->tip=1;}
} 

/* nb runs in string until next bracket of integer, returns 1 if bracket */

int nextbrac()
{int r=0;
 while (strng[pos]!='(' && !(strng[pos]<='9' && strng[pos]>='0')) pos++;
 if (strng[pos]=='(') {r=1;pos++;}
 return(r);
}

/* returns next integer and positions pos just after */

int nextnum()
{int i=0;
 while (strng[pos]<'0' || strng[pos]>'9') pos++;
 while (strng[pos]>='0' && strng[pos]<='9'){
  i*=10;
  i+=(strng[pos]-'0');
  pos++;
 }
 return(i);
}

/* is reads string from cluster.dat to strng */

instrng()
{int l=0,r=0,readit=1; 
 char c;
 pos=1;
 fscanf(usertree,"%c",&c);
 while (c!=';'){
               if (readit){ 
                strng[pos++]=c;
                if (strng[pos-1]==')') r++;
                if (strng[pos-1]=='(') l++;
                if (pos==STLG)
                 {printf("input phylogeny too large\n");exit(0);}
                }
		fscanf(usertree,"%c",&c);
                if (c==':') readit=0;
                if (c==',' || c==')' || c==';') readit=1; 
               }
 
 printf("finished reading strng: l,r,pos,s %d %d %d %s\n",l,r,pos,strng);
 if (l!=r){
 printf("bad input phylogeny\n");
 exit(0);}
}

constree(p)
struct auxnode **p;
{*p=(struct auxnode *)emalloc(sizeof(struct auxnode));
tipno++; 
if (nextbrac()){(*p)->tip=0;
		 constree(&(*p)->left);
		 constree(&(*p)->right);
                }

else {leafno++;(*p)->tip=1;}

(*p)->sqno=nextnum();
}

/* prints number and lengths of observed indels */

printlist()
{struct integlist *p;
 int i;
 fprintf(pout,"\nINSERTION-DELETIONS : ");
 fprintf(pout,"\n\n lengths: ");
 for (i=1,p=oust.indels.next;i<=oust.indell;p=p->next,i++)
    fprintf(pout,"%3d",p->pos);
 
 fprintf(pout,"\n numbers: ");
 
 for (i=1,p=oust.indels.next;i<=oust.indell;p=p->next,i++)
    fprintf(pout,"%3d",p->val);

 fprintf(pout,"\n\n");
}

/* outmat writes out the actually calculated distances between the
input sequences and writes -1 at positions that has not been
calculated */

outmat()
{int i,j;
fprintf(pout,"\nRELATIONSHIP BETWEEN PAIRS OF SEQUENCES: \n"); 
fprintf(pout,"     lower triangle distance between pairs\n"); 
fprintf(pout,"     upper triangle percent homology in alignment\n"); 
fprintf(pout,"      "); 
for (i=0;i<parr.nuseq;i++)
  fprintf(pout," %5d",i);  
  fprintf(pout,"\n");
for (i=0;i<parr.nuseq;i++)
 {fprintf(pout,"\n %5d",i);
  for (j=0;j<i;j++)
   if ((int)known(i,j))
    fprintf(pout," %5d",gdima(j,i)); 
   else 
    fprintf(pout," -1");
    fprintf(pout,"      ");
 if (parr.usertrae<2) /* if 2 means no alignment and only pairw. distances */
  for (j=i+1;j<parr.nuseq;j++)
  {if ((1+j)%21==0) fprintf(pout,"\n");
    fprintf(pout," %5d",percent(i,j));
  }

}
 fprintf(pout,"\n\n\n");
}

/* writes the phylogeny in Felsenstein format */

outphyl(p)
struct node *p;
{if (p->tip!=1)
 {phylsign('(',0,1);
  outphyl(p->left);
  phylsign(',',0,1); 
  outphyl(p->right);
  phylsign(')',0,1);
 }
phylsign('a',p->sqno,0);
phylsign(':',0,1);
phylsign('a',p->up,0);
}

/* writest a single sign in the phylogeny and skips to new line */  

phylsign(c,i,k)
char c;
int i,k;
{phylpos++;
 if (!(phylpos%50)) fprintf(pphyl,"\n");
 if (k) fprintf(pphyl,"%c",c);
 else fprintf(pphyl,"%d",i);
}

table1() /* symmetrized substitutions */
{int i,j;
 fprintf(pout,"\n TABLES OF GENETIC EVENTS: \n\n\n");
fprintf(pout,"   lower triangle: symmetrisized substitutions\n");  
fprintf(pout,"   upper triangle: mutation distance matrix\n\n"); 
 for (i=0;i<para.signnu-1;i++) fprintf(pout,"  %c",para.acids[i]);
 for (i=0;i<para.signnu-1;i++){
  fprintf(pout,"\n\n");
  fprintf(pout,"%c",para.acids[i]);
  for (j=0;j<i;j++)
  fprintf(pout,"%2d ",oust.substi[i][j]+oust.substi[j][i]);
  fprintf(pout,"   ");
  for (j=i+1;j<para.signnu-1;j++){
      fprintf(pout,"%2d ",mutd[i][j]);
     }
 }
  fprintf(pout,"\n\n");
}

/* fills the alignment with gapsigns */

alfill()
{int i,j;
 for (i=0;i<2*parr.nuseq-1;i++)
  for (j=0;j<globs.nmax;j++) alig[i*globs.nmax+j]='-';
}

/* writes the alignment */

outal()
{int i;
for (i=0;i<=(globs.aligtot/70);i++){
  if (parr.nuseq>9 && parr.udrest) overline(i*70);
  outal2(t.top,i*70);
  underline(i*70);
  fprintf(pout,"\n\n\n");
 }
}

/* writes out a block in the alignment */

outal2(p,k)
struct node *p;
int k;
{if (!p->tip) outal2(p->left,k);
 outline(k,p->sqno);
 if (!p->tip) outal2(p->right,k);
}

/* writes *'s under conserved sites */

underline(j)
int j;
{int i,k,boo;
  for (i=j;i<min(j+70,globs.aligtot);i++) 
  {boo=1;
   for (k=1;k<parr.nuseq;k++)
    if (alig[k*globs.nmax+i]!=alig[(k-1)*globs.nmax+i]) boo=0;
    if (boo) {oust.conssite++;fprintf(pout,"*");} 
    else fprintf(pout," ");
  }
}

/* writes histogram of mutatbility over the alignment */ 

overline(j)
int j;
{int i,k;
 for (k=8;(k+1);k--){
  for (i=j;i<min(j+70,globs.aligtot);i++) 
   if (oust.poiar[i][2]>=k) fprintf(pout,"#"); 
    else fprintf(pout," ");
  fprintf(pout,"\n");
  }
}

/* writes a line in the alignment */ 

outline(j,sqno)
int j,sqno;
{int i;
 if(parr.udanc || sqno<parr.nuseq){
    for (i=j;i<min(j+70,globs.aligtot);i++) 
       {fprintf(pout,"%c",alig[sqno*globs.nmax+i]);
        if (alig[sqno*globs.nmax+i]!='-') sek[sqno].len++;
       }
    fprintf(pout,"  %d  %d\n",sek[sqno].len,sqno);
   }
}

