# include "typedef.h"

/* (c) Copyright 1990 by Jotun Hein.  This program can be copied as long as
   this message is not deleted and it is distributed free of charge */

extern char *emalloc();

FILE *usertree,*pout,*pin,*pphyl,*pin2,*par,*fopen();
int known();
float priva(),atpos();
char usertreefile[30],fileseq[30],fileali[30],filetree[30];

struct inpar parr;
struct globa globs;

extern struct treep t;

/* in is used for all sequence indices and distances.
   int is used to reference md[], s[] and seq[] */

/* 
FILES:
    pin1 - contains sequences
    pin2 - contains mutation distances 
    par - contains parameters 
    pout - contains alignment
    pphyl - contains phylogeny
*/

main()
{
   if (NULL==(par=fopen("par.dat","r")))
      {printf("parameter file par.dat could not be opened\n");exit(0);}
   inpar();
   openfiles();
   initall();
   allo_stuff();
   if (parr.usertrae==1) {user(); improvepar();}  
   else analyze();
   inout(); 
   printf("finished analysis\n");
} 

openfiles()
{
   if (NULL==(pin2=fopen("mut.dat","r")))
      {printf("mutation distance file mut.dat could not be opened\n");exit(0);}
   open_seq_file();
   pphyl=fopen(filetree,"w");
   pout=fopen(fileali,"w");
}

open_seq_file()
{
 if (NULL==(pin=fopen(fileseq,"r")))
    {printf("sequence file %s could not be opened\n",fileseq);exit(0);}
}

analyze()
{
 t.top=(struct node *)emalloc(sizeof(struct node));
 t.top->tip=0;
 if (parr.nuseq>3){
  metric();
  printf("calculated %d pairwise distances of %d possible\n"
          ,t.comptot,parr.nuseq*(parr.nuseq-1)/2);
  t.compr=t.comptot;
  fasttree();
  printf("finished constructing distance tree using %d comparisons\n",
	  t.comptot-t.comptree);
  t.compr=t.comptot;
  improvedis();
  printf("finished improving distance tree using %d comparisons\n",
	 t.comptot-t.compr);
  t.compr=t.comptot;
  improvepar();
  printf("finished making and improving parsimony tree using %d comparisons\n",
	  t.comptot-t.compr);
  t.compr=t.comptot;
 }
 if (parr.nuseq==2){
  t.top->right=(struct node *)emalloc(sizeof(struct node));
  t.top->right->sqno=1;
  t.top->right->tip=1;
  t.top->left=(struct node *)emalloc(sizeof(struct node));
  t.top->left->sqno=0;
  t.top->left->tip=1;
  t.top->sqno=2;
  assigndive(t.top);
 }
 if (parr.nuseq==3){
  t.top->right=(struct node *)emalloc(sizeof(struct node));
  t.top->right->sqno=2;
  t.top->right->tip=1;
  t.top->left=(struct node *)emalloc(sizeof(struct node));
  t.top->left->sqno=3;
  t.top->left->tip=0;
  t.top->left->left=(struct node *)emalloc(sizeof(struct node));
  t.top->left->left->sqno=0;
  t.top->left->left->tip=1;
  t.top->left->right=(struct node *)emalloc(sizeof(struct node));
  t.top->left->right->sqno=1;
  t.top->left->right->tip=1;
  t.top->sqno=4;
  assigndive(t.top);
 }
}

/* reads in all parameters */

inpar()
{t.comptot=0;
 fscanf(par,"%d",&parr.seqtype);
 fscanf(par,"%d",&parr.nuseq); parr.alseq=2*parr.nuseq-1;
 fscanf(par,"%d",&parr.a);
 fscanf(par,"%d",&parr.b);parr.b=max(parr.b,2);
/* fscanf(par,"%d",&parcycmax); */ t.parcycmax=0;
 t.inhibit =3.5; /* originally 1.5 */
 /* fscanf(par,"%d",&t.discycmax);
 fscanf(par,"%f",&inhibit); */
 fscanf(par,"%d",&parr.udanc);
 parr.udmat=parr.udrest=1;
/* fscanf(par,"%d",&screen); */ parr.screen=0;
 fscanf(par,"%d\n",&parr.usertrae);
 fscanf(par,"%s\n",fileseq);
 fscanf(par,"%s\n",filetree);
 fscanf(par,"%s\n",fileali);
 fscanf(par,"%s\n",usertreefile);
 if (parr.seqtype) printf("analysis of %d protein sequences\n",parr.nuseq);
 else printf("analysis of %d DNA sequences\n",parr.nuseq);
 printf("gap penalty: %d + k* %d\n",parr.a,parr.b);
/*
 printf("There will be %d cycles of improvements on the parsimony tree\n",
	 parcycmax);
*/
 if (!parr.usertrae) printf("The program will reconstruct the phylogeny\n");
 else printf("The topology is supplied by the user on %s\n",usertreefile);
 printf("The alignment will be written on %s\n",fileali);
 printf("The phylogeny will be written on %s\n",filetree);
 printf("finished reading parameters\n");
}

