#include "typedef.h"

/* (c) Copyright 1990 by Jotun Hein.  This program can be copied as long as
   this message is not deleted and it is distributed free of charge */

   extern int di();
   extern char *emalloc(),*malloc();
   extern FILE *pout;
   
   arrow *links;
   struct nuclink *good_edge();
   int mutd[MAXSIGNS][MAXSIGNS],(*md)[3],(*mds),*adr, globali(), mdis(), pos1;
   int (*nodes) [4];
   
   static int *dx,*dy,*row,a,b,pi0,pi1,pi2,m00, m01, m02, m10, m11, m20, m22;
  
   static int b1,b2,l1,l2;
   static char *se1,*se2;
   static struct nucnode *sg1,*sg2;

   struct param para;
   struct esko ukko;
   struct back track;
   struct alilocspe als;
   struct aliglospe ags;

   extern struct inpar parr;
   extern struct sekvens *sek;
   extern struct treep t;
   extern struct globa globs;

/* mij contains current minimum of node of type i that has been
   preceded by a node of type j */

/* globali calculates dij subject to the constraint that they are within a
   certain narrow band of the diagonals, this band is determined by
   bd and the difference in length of two sequences */

int
globali(s1,s2,s3)
int s1,s2,s3;
{init_globali(s1,s2,s3);
 prealign();
 t.comptot++;
 if (s3) prune(s3);
 if (parr.screen)
   printf("s1,s2,dis %d %d %d\n",s1,s2,ags.w);
 if (parr.screen && s3) 
   printf("seq.graph.,length(full,reduced): %d %d %d\n",ags.s3,track.ltot,track.ltotr);
 return(ags.w);
}

pred1(p)
struct nuclink *p;
{return(p->nextnode-b1);}

pred2(p)
struct nuclink *p;
{return(p->nextnode-b2);}

minreal(l1,l2)
int l1,l2;
{int p=coor(l1,l2),t,m;
 m=min3(md[p][0],md[p][1],md[p][2]);
 if (md[p][1]==m) t=1;
 if (md[p][2]==m) t=2;
 if (md[p][0]==m) t=0;
return(t);
}

distance(l1,l2)
int l1,l2;
{int p=coor(l1,l2);
 if (ags.s3) return(min3(md[p][0],md[p][1],md[p][2]));
 else return(mds[p]);
}


locali(b1,b2,sl1,sl2,pn)
int b1,b2,sl1,sl2,*pn;
{
 wall(sl1,sl2);

 if (parr.screen>2) printf("test locali b1,b2 %d %d l1,l2 %d %d\n",b1,b2,sl1,sl2);

 init_locali(b1,b2,sl1,sl2);
 if (!ags.s3) seqcalcl();
 else calcl();
 
*pn+=distance(sl1,sl2);

 if (ags.s3)  backgraf();

}

line_align0(b1,b2,l,pn)
int b1,b2,l,*pn;
{int i,k=0;
 
 for (i=0;i<l;i++)
    {k+=di(good_edge(ags.sg[0][i+b1].first)->nucset,
           good_edge(ags.sg[1][i+b2].first)->nucset);
     if (ags.s3) addstep0(i+b1,i+b2);
    }

 *pn+=k;
}

addstep_common()
{struct nuclink *p;
 track.ltot++;
 p=(struct nuclink *)emalloc(sizeof(struct nuclink));
 p->next=track.aux[track.ltot].first;
 track.aux[track.ltot].first=p;
 track.aux[track.ltot].first->nextnode=track.ltot-1;
}

struct nuclink *
good_edge(f)
struct nuclink *f;
{struct nuclink *p=f;
 while (p->type<0) p=p->next;
 return(p);
}

addstep0(x,y)
int x,y;
{struct nuclink *p;
 addstep_common();
 p=track.aux[track.ltot].first;
 p->left=good_edge(ags.sg[0][x].first);
 p->right=good_edge(ags.sg[1][y].first);
 p->type=0;
 hfs(p->left->nucset,p->right->nucset,&p->nucset);
}

line_align1(b1,l,pn)
int b1,l,*pn;
{int i;
 for (i=0;i<l;i++) if (ags.s3) addstep1(i+b1);

 *pn+=a+b*l;
}

addstep1(x)
int x;
{
 addstep_common();
 track.aux[track.ltot].first->left=good_edge(ags.sg[0][x].first);
 track.aux[track.ltot].first->right=NULL;
 track.aux[track.ltot].first->type=1;
 track.aux[track.ltot].first->nucset=good_edge(ags.sg[0][x].first)->nucset;
}

line_align2(b2,l,pn)
int b2,l,*pn;
{int i;
 for (i=0;i<l;i++) if (ags.s3) addstep2(i+b2);

 *pn+=a+b*l;
}

addstep2(y)
int y;
{addstep_common();
 track.aux[track.ltot].first->left=NULL;
 track.aux[track.ltot].first->right=good_edge(ags.sg[1][y].first);
 track.aux[track.ltot].first->type=2;
 track.aux[track.ltot].first->nucset=good_edge(ags.sg[1][y].first)->nucset;
}

init_globali(s1,s2,s3)
int s1,s2,s3;
{  ags.w=0;   
   track.ltot=0;
   a=parr.a; b=parr.b;
   ags.s[0]=s1;ags.s[1]=s2;ags.s3=s3;
   ags.l[0]=sek[s1].p->nl; ags.l[1]=sek[s2].p->nl;
   if (seq_kind(0)) ags.se[0]=sek[s1].se; 
   if (seq_kind(1)) ags.se[1]=sek[s2].se;
   sg1=ags.sg[0]=sek[s1].s; 
   sg2=ags.sg[1]=sek[s2].s;
 
   if (s3) sek[s3].p=(struct domain *)emalloc(sizeof(struct domain));
 
}
 
init_locali(beg1,beg2,sl1,sl2)
int beg1,beg2,sl1,sl2;
{  reallmd(max(sl1,sl2));
   als.b1=b1=beg1;
   als.b2=b2=beg2;
   als.l1=l1=sl1;
   als.l2=l2=sl2;
   se1=(&ags.se[0][beg1]); 
   se2=(&ags.se[1][beg2]);
   sg1=(&ags.sg[0][beg1]); 
   sg2=(&ags.sg[1][beg2]);
   dx=ukko.dx;
   dy=ukko.dy;
   row=ukko.row;
   setdim(b2,sl2);
}

reallmd(maxlength)
int maxlength;
{
if (!ags.s3){
 if (globs.tota>globs.nmaxl && globs.nmaxl!=MEMORY){
    if (globs.nmaxl) free(mds);
    globs.nmaxl=min(MEMORY,max3(2000,(int)((0.06*maxlength+
           2.0*sqrt((double)maxlength))*maxlength),globs.tota));
    mds=NULL;
    while (!(mds=(int (*)) malloc(globs.nmaxl*sizeof(int))))
       globs.nmaxl/=2;

    if (parr.screen>2)
       printf("making bigger 1-array nmaxl  %d  %d \n",globs.nmaxl,globs.tota);
   }
 }

else{ if (mds!=NULL){free(mds);globs.nmaxl=0;mds=NULL;}
 if (globs.tota>globs.nmaxl && globs.nmaxl!=MEMORY){
    if (globs.nmaxl) free(md);
    globs.nmaxl=min(MEMORY,max3(2000,(int)((0.06*maxlength+
           2.0*sqrt((double)maxlength))*maxlength),globs.tota));
    md=NULL;
    while (!(md=(int (*) [3]) malloc(3*globs.nmaxl*sizeof(int))))
       globs.nmaxl/=2;

    if (parr.screen>2)
       printf("making bigger 3-array nmaxl %d  %d \n",globs.nmaxl,globs.tota);
   }
 }

}

setdim(b2,len2)
int b2,len2;
{bfsg(sg2,b2,len2);
 if (parr.screen>2)
   printf("area,l2 %d %d\n",globs.tota,len2);
}
 
 /*
 this band is lined with two bands of high numbers, that prevents any 
   backtracking path to walk out into this area */

initl()
{if (ags.s3){
    md[0][0]=md[0][1]=md[0][2]=SBIG;
    md[coor(0,0)][1]=md[coor(0,0)][2]=SBIG;
    md[coor(0,0)][0]=0;
   }
 else {mds[coor(0,0)]=0;mds[0]=SBIG;}
}

onecalcl(i,j)
int i,j;
{int p,p0,p1,p2;
 p=coor(i,j);
 if (outdeg(sg1[i].first)==1 && outdeg(sg2[j].first)==1)
    {p0=coor(pred1(sg1[i].first),pred2(sg2[j].first));
     p1=coor(pred1(sg1[i].first),j);
     p2=coor(i,pred2(sg2[j].first));
     md[p][0]=min3(md[p0][0],md[p0][1],md[p0][2])+
                   di(sg1[i].first->nucset,sg2[j].first->nucset);
     md[p][1]=b+min(md[p1][0]+a,md[p1][1]);
     md[p][2]=b+min(md[p2][0]+a,md[p2][2]);
 }
 else  {
     pi0=pi1=pi2=m00=m01=m02=m10=m11=m20=m22=SBIG;
     pseudo(i,j);
     dive(i,j);
     md[p][0]=min4(pi0,m00,m01,m02);
     md[p][1]=min3(pi1,m10+a+b,m11+b);
     md[p][2]=min3(pi2,m20+a+b,m22+b);
  }
} 

seqonecalcl(i,j)
int i,j;
{int p=coor(i,j),p1=coor(i-1,j-1),p2=coor(i-1,j),p3=coor(i,j-1),b2=2*b;
 mds[p]=min(mds[p1]+mutd[se1[i]][se2[j]],min(mds[p2],mds[p3])+b2);
} 


calcl()
{ initl();
  partl();
}

seqcalcl()
{ initl();
  seqpartl();
}

/* part1 calculates a tetragon of dij spanned by (0,0), (0,ye), (xe+ye,ye) and
   (xe,0) */

int
seqpartl()
{int x,y;
 for (x=1;x<=ukko.dy[0];x++) seqonecalcl(x,0); 
 for (y=1;y<=l2;y++)
    for (y=1;y<=l2;y++) seqcalcline(y);
}
 
int
partl()
{int x,y;
   for (x=1;x<=ukko.dy[0];x++) onecalcl(x,0); 
   for (y=1;y<=l2;y++) calcline(y);
}

int
recover(r)
int r;
{int i;
 track.presblok=r;
 for (i=track.blok[r+1]-1;i>=track.blok[r];i--){
    if (ukko.ladder[adr[i]]==r) calcline(adr[i]);
 }
} 

seqcalcline(y)
int y;
{int x;
  for (x=dx[y];x<=dy[y];x++)  seqonecalcl(x,y);
}

calcline(y)
int y;
{int x;
  for (x=dx[y];x<=dy[y];x++)  onecalcl(x,y);
}

pseudo(i,j)
int i,j;
{struct nuclink *p1,*p2;

 p1=sg1[i].first;
 while (p1!=NULL && p1->type<0){
   updater(pred1(p1),j);
   p1=p1->next;
  }


 p2=sg2[j].first;
 while (p2!=NULL && p2->type<0){
    updater(i,pred2(p2));
    p2=p2->next;
  }

 p1=sg1[i].first;
 while (p1!=NULL && p1->type<0){
    p2=sg2[j].first;
    while (p2!=NULL && p2->type<0){
       updater(pred1(p1),pred2(p2));
       p2=p2->next;
      }
    p1=p1->next;
   } 

}

dive(i,j)
int i,j;
{struct nuclink *p1,*p2;
 int maux;

 p1=sg1[i].first;
 while (p1!=NULL){
    if (p1->type>=0){
       if (md[coor(pred1(p1),j)][0]<m10) 
          m10=md[coor(pred1(p1),j)][0];
       if (md[coor(pred1(p1),j)][1]<m11) 
          m11=md[coor(pred1(p1),j)][1];
       }
    p1=p1->next;
    }

 p1=sg2[j].first;
 while (p1!=NULL){
    if (p1->type>=0){
       if (md[coor(i,pred2(p1))][0]<m20)
          m20=md[coor(i,pred2(p1))][0];
       if (md[coor(i,pred2(p1))][2]<m22) 
          m22=md[coor(i,pred2(p1))][2];
      }
    p1=p1->next;
   }

 p1=sg1[i].first;
 while (p1!=NULL){
    p2=sg2[j].first;
    while (p2!=NULL){
       if (p1->type>=0 && p2->type>=0){
          maux=md[coor(pred1(p1),pred2(p2))][0]+di(p1->nucset,p2->nucset); 
          if (maux<m00) m00=maux; 
          maux=md[coor(pred1(p1),pred2(p2))][1]+di(p1->nucset,p2->nucset); 
          if (maux<m01) m01=maux; 
          maux=md[coor(pred1(p1),pred2(p2))][2]+di(p1->nucset,p2->nucset); 
          if (maux<m02) m02=maux; 
          } 
       p2=p2->next;
       }
    p1=p1->next;
    }
 
}

updater(i,j)
int i,j;
{
    if (md[coor(i,j)][0]<pi0) 
      pi0=md[coor(i,j)][0];
    if (md[coor(i,j)][1]<pi1) 
      pi1=md[coor(i,j)][1];
    if (md[coor(i,j)][2]<pi2) 
      pi2=md[coor(i,j)][2];
}

/* Distance calculation has ended and backtracking begun */

backgraf()
{
 pos1=track.edgeno=0; 
 track.ltotr=track.ltot;
 nodes[0][0]=l1;
 nodes[0][1]=l2;
 nodes[0][2]=minreal(l1,l2);
 nodes[0][3]=distance(l1,l2); 
 bfsb();
 if (track.ltot>globs.nmax) {printf("too many nodes\n");exit(0);}
 if (track.edgeno>4*globs.nmax) {printf("too many track.edges\n");exit(0);}
 makebtg();
}

children(x,y,t,m)
int x,y,t;
int m;
{
   pseudob(x,y,t,m); 
   diveb(x,y,t,x,y,m);
}

bfsb()
{
 while (pos1!=(track.ltot-track.ltotr+1)){ /* this condition = array is empty */
   children(nodes[pos1][0],nodes[pos1][1],
            nodes[pos1][2],nodes[pos1][3]);
   pos1++; /* this is deleting an element from the queue */
 }
}

pseudob(i,j,t,m)
int i,j;
{struct nuclink *p1,*p2;

 p1=sg1[i].first;
 while (p1!=NULL && p1->type<0){
    if (mdis(pred1(p1),j,t)==m && pred1(p1)>=0) 
       diveb(i,j,t,pred1(p1),j,m);
    p1=p1->next;
    }

 p2=sg2[j].first;
 while (p2!=NULL && p2->type<0){
    if (mdis(i,pred2(p2),t)==m && pred2(p2)>=0) 
       diveb(i,j,t,i,pred2(p2),m);
    p2=p2->next;
    }

 p1=sg1[i].first;
 while (p1!=NULL && p1->type<0){
    p2=sg2[j].first;
    while (p2!=NULL && p2->type<0){
       if (mdis(pred1(p1),pred2(p2),t)==m && pred1(p1)>=0 && pred2(p2)>=0) 
          diveb(i,j,t,pred1(p1),pred2(p2),m);
       p2=p2->next;
       }
    p1=p1->next;
    }
}

diveb(x,y,t,i,j,m)
int x,y,t,i,j;
int m;
{struct nuclink *p1,*p2;
 if (t==1){
    p1=sg1[i].first;
    while (p1!=NULL){
       if (p1->type>=0 && pred1(p1)>=0){
          if (mdis(pred1(p1),j,0)+a+b==m) 
             another1(x,y,p1,0,mdis(pred1(p1),j,0)); 
          if (mdis(pred1(p1),j,1)+b==m) 
             another1(x,y,p1,1,mdis(pred1(p1),j,1)); 
       }
    p1=p1->next;
    }
 }

 if (t==2){
    p2=sg2[j].first;
    while (p2!=NULL){
       if (p2->type>=0 && pred2(p2)>=0){
          if (mdis(i,pred2(p2),0)+a+b==m)
             another2(x,y,p2,0,mdis(i,pred2(p2),0)); 
          if (mdis(i,pred2(p2),2)+b==m) 
             another2(x,y,p2,2,mdis(i,pred2(p2),2)); 
       }
       p2=p2->next;
    }
 }

 if (!t){
    p1=sg1[i].first;
    while (p1!=NULL){
       p2=sg2[j].first;
       while (p2!=NULL){
          if (p1->type>=0 && p2->type>=0 && pred1(p1)>=0 && pred2(p2)>=0){
            if (mdis(pred1(p1),pred2(p2),0)+di(p1->nucset,p2->nucset)==m) 
               another0(x,y,p1,p2,0,mdis(pred1(p1),pred2(p2),0)); 
            if (mdis(pred1(p1),pred2(p2),1)+di(p1->nucset,p2->nucset)==m) 
               another0(x,y,p1,p2,1,mdis(pred1(p1),pred2(p2),1)); 
            if (mdis(pred1(p1),pred2(p2),2)+di(p1->nucset,p2->nucset)==m) 
               another0(x,y,p1,p2,2,mdis(pred1(p1),pred2(p2),2)); 
          } 
          p2=p2->next;
       }
       p1=p1->next;
    }
  }
}

another0(x,y,p1,p2,t,m)
struct nuclink *p1,*p2;
int x,y,t;
int m;
{addedge0(x,y,t,p1,p2);
 if (new(pred1(p1),pred2(p2),t)) addnode(pred1(p1),pred2(p2),t,m);
}

another1(x,y,p,t,m)
struct nuclink *p;
int x,y,t;
int m;
{addedge1(x,y,t,p);
 if (new(pred1(p),y,t)) addnode(pred1(p),y,t,m);
}

another2(x,y,p,t,m)
struct nuclink *p;
int x,y,t;
int m;
{addedge2(x,y,t,p);
 if (new(x,pred2(p),t)) addnode(x,pred2(p),t,m);
}

int new(x,y,t)
int x,y,t;
{int i=track.ltot-track.ltotr,r=1;
 while (3*(l1*y+x)+t<cardi(i) && i) i--;
 if (3*(l1*y+x)+t==cardi(i)) r=0;
 return(r);
} 

int addnode(x,y,t,m)
int x,y,t;
int m;
{int i=track.ltot-track.ltotr,j,l;
 while ((3*(l1*y+x)+t>cardi(i)) && i) i--;
 if (3*(l1*y+x)+t!=cardi(i)){track.ltot++;i++;
 for (j=track.ltot-track.ltotr;j>i;j--)
   for (l=0;l<=3;l++) nodes[j][l]=nodes[j-1][l];
  nodes[i][0]=x;
  nodes[i][1]=y;
  nodes[i][2]=t;
  nodes[i][3]=m;
 }
}

addedge_common(x,y,t,p)
int x,y,t;
struct nuclink **p;
{track.edges[track.edgeno][0]=x;
 track.edges[track.edgeno][1]=y;
 track.edges[track.edgeno][5]=t;
 *p=(struct nuclink *)emalloc(sizeof(struct nuclink));
 links[track.edgeno]=(*p);
 track.edgeno++;
}

/* addedge* adds an edge to track.aux going from b to e of type * */

addedge0(x,y,t,p1,p2)
int x,y,t;
struct nuclink *p1,*p2;
{struct nuclink *p;
 track.edges[track.edgeno][2]=0;
 track.edges[track.edgeno][3]=pred1(p1);
 track.edges[track.edgeno][4]=pred2(p2);
 addedge_common(x,y,t,&p);
 p->left=p1;
 p->right=p2;
 hfs(p1->nucset,p2->nucset,&p->nucset);
 p->type=0;
}

addedge1(x,y,t,p1)
int x,y,t;
struct nuclink *p1;
{struct nuclink *p;
 track.edges[track.edgeno][2]=1;
 track.edges[track.edgeno][3]=pred1(p1);
 track.edges[track.edgeno][4]=y;
 addedge_common(x,y,t,&p);
 p->left=p1;
 p->nucset=p1->nucset;
 p->type=1;
}  

addedge2(x,y,t,p2)
int x,y,t;
struct nuclink *p2;
{struct nuclink *p;
 track.edges[track.edgeno][2]=2;
 track.edges[track.edgeno][3]=x;
 track.edges[track.edgeno][4]=pred2(p2);
 addedge_common(x,y,t,&p);
 p->right=p2;
 p->nucset=p2->nucset;
 p->type=2;
}  

int
mdis(x,y,t)
int x,y,t;
{
if (ukko.ladder[y] && ukko.ladder[y]!=track.presblok) recover(ukko.ladder[y]);
return(md[coor(x,y)][t]);
}

makebtg()
{int i,b,e;
 
 for (i=0;i<track.edgeno;i++){
    b=track.ltot-findnode(track.edges[i][0],track.edges[i][1],track.edges[i][2]);
    e=track.ltot-findnode(track.edges[i][3],track.edges[i][4],track.edges[i][5]);
    links[i]->next=track.aux[b].first;
    track.aux[b].first=links[i];
    track.aux[b].first->nextnode=e;
 } 
}


/* following can be speeded up considerably */

int findnode(x,y,t)
int x,y,t;
{int found=0,r,l=0,u=track.ltot-track.ltotr;
 double v,fr,fu,fl;
 fl=(double)cardi(l);
 fu=(double)cardi(u);
 v=(double)(3*(l1*y+x)+t);
 r=l+(int)(((v-fl)*(double)(u-l))/(fu-fl));
 fr=(double)cardi(r);
 
while (!found){
 if (v<fr) {l=r;
            fl=fr;
            r=max(r+1,l+(int)(((v-fl)*(double)(u-l))/(fu-fl)));
            fr=(double)cardi(r);
           }
 else 
 if (v>fr) {u=r;
            fu=fr;
            r=min(r-1,l+(int)(((v-fl)*(double)(u-l))/(fu-fl)));
            fr=(double)cardi(r);
           }
 else found=1;
 }
return(r);
}

int cardi(i)
int i;
{int x=nodes[i][0],y=nodes[i][1],t=nodes[i][2];
return(3*(l1*y+x)+t);}

