# include "typedef.h"

/* (c) Copyright 1990 by Jotun Hein.  This program can be copied as long as
   this message is not deleted and it is distributed free of charge */

extern int *posi,di();
extern char logtide(),*emalloc();
extern FILE *pout;
extern float finv();

float area,eleng(),fakt(),logl();

static int g,m,rx,ry,ds1,dx1,dy1;

struct pres prep;

extern struct param para;
extern struct esko ukko;
extern struct aliglospe ags;
extern struct alilocspe als;
extern struct sekvens *sek;
extern struct inpar parr;
extern struct globa globs;

prealign()
{
 init_pre();
 hashboth();
 area=(float)((dx1+dy1+1)*ags.stln[1])*
      ((float)ags.stln[0]/(float)ags.l[0]);
 makegr();
 list_dist();
 piece_align();
 freegr();
}


init_pre()
{m=3; 
 if (parr.seqtype) g=7;
 else              g=para.sl;
 rx=0;ry=0;
 initgr();
 initband();
}

piece_align()
{globs.tota=para.sl;longsegm(1,0);
 gluing(ags.l[0]+1,ags.l[1]+1);
 if (parr.screen>2)
    printf("puff %d segm %d\n",prep.puffno,prep.alinum);
}

/* determines the band that must be used in dyn.prog. */

wall(sl1,sl2)
int sl1,sl2;
{int ds,i,diff,midp;
 float dydx;
 globs.tota=1;
 diff=max(sl1-sl2,sl2-sl1);
 ds=diff+(int)max(5.0,1.5*sqrt((float)sl1));
 dydx=(float)(sl1)/(float)(sl2);

 for (i=0;i<=sl2;i++){
    midp=(int)(float)i*dydx;
    ukko.dx[i]=max(0,midp-ds);
    ukko.dy[i]=min(sl1,midp+ds);
    globs.tota+=(ukko.dy[i]-ukko.dx[i]+1);
   }
}

/* makes first very coarse band to determine which segments are of interest */

initband()
{ds1=(int)max(5.0,0.025*(float)globs.lave+2.5*sqrt((float)globs.lave));
 if (ags.l[0]>ags.l[1]){dx1=ags.l[0]-ags.l[1]+ds1;dy1=ds1;}
 else {dy1=ags.l[1]-ags.l[0]+ds1;dx1=ds1;}
}

/* runs through optimal path of segments & find chunks of connected segments */

longsegm(n,l)
int n,l;
{int found=0;
 struct elem *p;
 p=prep.alipoi[n].next;
 while (p!=NULL){  
    if (good_link(n,p->sqno) && !found){
       found=1; 
       if (underbo(n,p->sqno,&l) && p->sqno) longsegm(p->sqno,l);
       else {longsegm(p->sqno,para.sl); 
             if (arratia(l,n)) sigsegm(l,n);
            } 
      }
    p=p->next;
   }
}

/* I am very uneasy about the formulas used to declare segments significant,
   they should be checked and probably sustituted with one about the signi-
   ficance of the whole island  */

arratia(l,n)
int l,n;
{int *mmm,ma=0,st,i,signi=0,pos=0,mm,lastpos,maxl,d;
 mmm=(int *)emalloc(2*l*sizeof(int));
 d=diagonal(n); 
 st=prep.alipoi[n].start[1]-para.sl+1; 

 for (i=0;i<l;i++) 
  mmm[i]=(!di(ags.sg[0][i+st].first->nucset,ags.sg[1][i+d+st].first->nucset));
 for (i=0;i<l;i++) ma+=mmm[i];

 for (i=0;i<5 && !signi;i++){mm=0;pos=0;
    while (mm<=i && pos<l){if (!mmm[pos]) mm++; pos++;}
    if (mm>i) mm=i;
    if (pos==l) pos--;
    maxl=(pos-mm);lastpos=0;
    while (pos<l) {pos++;
       if (!mmm[pos]) 
          while (mmm[lastpos] && lastpos<l) lastpos++; 
       lastpos++;
       maxl=max(maxl,pos-lastpos-mm+1);
      }
    if ((float)maxl>=eleng((float)i) || ma>4*para.sl) signi=1;
  }
free(mmm);

 for (i=1;i<l;i++) 
  if (outdeg(ags.sg[0][i+st].first)>1 || 
      outdeg(ags.sg[1][i+d+st].first)>1) signi=0;

return(signi);
}



float eleng(dk)
float dk;
{float d=0.0;
 if (seqs_kind()) d=1.0;
 return(1.0+d+logl(area)+logl(logl(area))*dk+
		logl((1.0-para.la)/para.la)-logl(fakt((int)dk)));
}


float logl(d)
float d;
{return(log(d)/log(1.0/para.la));}



float fakt(k)
int k;
{float r=1.0;
 int i;
 for (i=1;i<=k;i++) r*=(float)i;
 return(r);
}

/* returns numerical value of a */

num(a)
int a;
{if (a>=0) return(a);
 else      return((-1)*a);
}


/* is u a minimal extension of l */

good_link(u,l)
int u,l;
{return(prep.alipoi[u].w==prep.alipoi[l].w+g-indel_cost(u,l));}


/* on which diagonal is segment i */

diagonal(i)
int i;
{return(prep.alipoi[i].start[2]-prep.alipoi[i].start[1]);}


/* is n1 below n2 and on the same diagonal */

int underbo(n1,n2,l)
int n1,n2,*l;
{int step;
 if (n2 && n1!=1 && diagonal(n1)==diagonal(n2)){
    step=(prep.alipoi[n1].start[1]-prep.alipoi[n2].start[1]);
    (*l)+=step;
    if (n1==1) (*l)=para.sl;
    return(1);}
  else return(0);
}


/* aligns the new pieces corresponding to l & n */

sigsegm(l,n)
int l,n;
{int x,y;
if (n!=1){
   x=max(0,prep.alipoi[n].start[1]-para.sl)+1;
   y=max(0,prep.alipoi[n].start[2]-para.sl)+1;

   gluing(x,y);

   line_align0(x,y,l,&ags.w);

   rx=x+l-1;
   ry=y+l-1;
  }
}

/* are the pieces between two seqments an ordinary alignment, or horizontal or
   vertical lines */

gluing(x,y)
int x,y;
{
 if (x>rx+1 && y>ry+1)  locali(rx,ry,x-rx-1,y-ry-1,&ags.w);
 if (x>rx+1 && y==ry+1) line_align1(rx+1,x-rx-1,&ags.w);
 if (x==rx+1 && y>ry+1) line_align2(ry+1,y-ry-1,&ags.w);
}

/* frees the graph used for segment graph */

freegr()
{int i;
 for (i=0;i<prep.alinum;i++){
    herut(prep.alipoi[i].next);
    prep.alipoi[i].next=NULL;
 }
}

herut(p)
struct elem *p;
{if (p!=NULL){herut(p->next);free(p);}
}


/* adds another common segment to the set of nodes in sgm=graph */

extracom(x,y)
int x,y;
{if ((y-x)<dy1 && (x-y)<dx1) {
  prep.alipoi[prep.alinum].next=NULL;
  prep.alipoi[prep.alinum].start[1]=x;prep.alipoi[prep.alinum].start[2]=y;
  prep.alinum=min(globs.nmax-1,prep.alinum+1);
 }
}


/* adds all common segments to sgm-gr. that results from seg-type at pos. j in
   the second sequence/graph */

add_seg(m,j)
int m,j;
{struct elem *p=prep.hash[m].next;
 while (p!=NULL) {extracom(p->sqno,j);p=p->next;} 
}


/* adds edges to sgm-gr. */

makegr()
{int k;
 for (k=0;k<=prep.alinum;k++) posi[k]=0;
 for (k=2;k<prep.alinum;k++){
    pre_dive(1,k);
    link_them(1,k);
    posi[1]=posi[k]=1;de_dive(1);
   }
/*
 grannies(1);
 for (k=prep.alinum-1;k>2;k--) grannies(k);
*/
}


/* runs through segm.gr. and resets nodes labelled 1 to 0 */

de_dive(n)
int n;
{struct elem *p=prep.alipoi[n].next;
 if (posi[n]){
    posi[n]=0;
    while (p!=NULL){
       de_dive(p->sqno);
       p=p->next;
      }
   }
}


/* runs through gr and processes nodes just below l */

pre_dive(u,l)
int u,l;
{struct elem *p=prep.alipoi[u].next;
 if (!posi[u]){posi[u]=1;
    if (stor(l,u)) 
       {fjern_den(l,u);link_them(l,u);fjern_den(1,u);}
    else while (p!=NULL){
       pre_dive(p->sqno,l);
       p=p->next;
      }
   }
}


/* removes edge between u & l */

fjern_den(u,l)
int u,l;
{struct elem **p=(&prep.alipoi[u].next),*paux;
 while ((*p)!=NULL){
   if ((*p)->sqno==l){paux=(*p);
                      (*p)=(*p)->next;
                      free(paux);
                     }
   else p=(&(*p)->next);
  }
}

 
/* makes the simple graph with two nodes one very big, one very small */

initgr()
{prep.alinum=2;
 prep.alipoi[0].start[1]=prep.alipoi[0].start[2]=(-10000);
 prep.alipoi[1].start[1]=SBIG+ags.l[0];
 prep.alipoi[1].start[2]=SBIG+ags.l[1];
 prep.alipoi[1].next=(struct elem *)emalloc(sizeof(struct elem));
 prep.alipoi[1].next->sqno=0;
 prep.alipoi[1].next->next=NULL;
 prep.alipoi[0].next=NULL;
}


/* can p be father to n */

int
stor(p,n)  /* returns (p>n) */ 
int p,n;
{
 if (diagonal(n)==diagonal(p))
   return((prep.alipoi[p].start[1]>prep.alipoi[n].start[1]) 
       && (prep.alipoi[p].start[2]>prep.alipoi[n].start[2]));
 else
   return((prep.alipoi[p].start[1]>prep.alipoi[n].start[1]+para.sl-1) 
       && (prep.alipoi[p].start[2]>prep.alipoi[n].start[2]+para.sl-1));
}

/* calculates weight of optimal list */

list_dist()
{int i;
 struct elem *p;
 prep.alipoi[0].w=0;

 for (i=2;i<prep.alinum;i++){
    p=prep.alipoi[i].next;prep.alipoi[i].w=(-1)*100000;
    while (p!=NULL){ 
       prep.alipoi[i].w=max(prep.alipoi[i].w,
                        g+prep.alipoi[p->sqno].w-indel_cost(i,p->sqno));
       p=p->next;
      }
   }

  p=prep.alipoi[1].next;prep.alipoi[1].w=(-1)*100000;
  while (p!=NULL){ 
     prep.alipoi[1].w=max(prep.alipoi[1].w,
                     g+prep.alipoi[p->sqno].w-indel_cost(1,p->sqno));
     p=p->next;
    }
}


/* weight of diagonal difference between a and b */

indel_cost(a,b)
int a,b;
{int d=num(diagonal(a)-diagonal(b));
 return(m*(int)sqrt((double)d));
}


/* links u to l and remove the siblings to l that becomes dominated */

link_them(u,l)
int u,l;
{struct elem *p=prep.alipoi[u].next;
 int already=0;
 while (p!=NULL){
    if (stor(p->sqno,l)) already=1;
    p=p->next;
   }

 p=prep.alipoi[u].next;
 while (p!=NULL){
    if (stor(l,p->sqno)) fjern_den(u,p->sqno);
    p=p->next;
   }

 if (!already){
   p=(struct elem *)emalloc(sizeof(struct elem));
   p->sqno=l; 
   p->next=prep.alipoi[u].next;
   prep.alipoi[u].next=p;
  }
}

/* dekinks the graph by adding nodes between node and grandchildren, if child is
   out of line */

grannies(k)
int k;
{struct elem *p=prep.alipoi[k].next;
 while (p!=NULL){check_grandchildren(k,p->sqno);p=p->next;}
}


check_grandchildren(u,l)
int u,l;
{struct elem *p=prep.alipoi[l].next;
 if (l)
    while (p!=NULL){
       if (p->sqno)
          if (outside(u,l,p->sqno)) 
             if (!connected(u,p->sqno))
                link_them(u,p->sqno);
       p=p->next;
      }
}


/* checks if l can be reached from l monotonically */

connected(u,l)
int u,l;
{int found=0;
 con_dive(u,l,diagonal(u)-diagonal(l),&found);
 de_dive(u);
 return(found);
}
 
con_dive(u,l,d,f)
int u,l,d,*f;
{struct elem *p=prep.alipoi[u].next;
 if (u==l) *f=1;
 if (!posi[u] && stor(u,l)){posi[u]=1;
    while (p!=NULL && (diagonal(u)-diagonal(p->sqno))*d>=0){ 
       con_dive(p->sqno,l,d,f);
       p=p->next;
     }
   }
}

outside(u,m,l)
int u,m,l;
{return(diagonal(m)<min(diagonal(u),diagonal(l)) ||
        diagonal(m)>max(diagonal(u),diagonal(l)));
}
